﻿using System;
using System.IO;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace KeyShop
{
    internal class clsSettings
    {

        internal clsSettings()
        {
            _LoadSettings();
        }


        //########################################################
        //
        //  private variable
        //
        //########################################################

        private XmlDocument mySettings_;
        private string      myFilePath_ = "./KeyShop.conf";


        //########################################################
        //
        //  internal function
        //
        //########################################################

        internal string xGetAttribute(string ElementName, string AttributeName)
        {
            return _GetAttribute(ElementName, AttributeName);
        }

        internal void xSetAttribute(string ElementName, string AttributeName, string Value)
        {
            _SetAttribute(ElementName, AttributeName, Value);
        }

        internal void xSaveSettings()
        {
            _SaveSettings();
        }

        //########################################################
        //
        //  private function
        //
        //########################################################

        private void _LoadSettings()
        {
            StreamReader sr = null;

            try
            {
                myFilePath_ = Path.GetFullPath(myFilePath_);
                mySettings_ = new XmlDocument();
                if (!File.Exists(myFilePath_)) _InitializeSettings();

                sr = new StreamReader(myFilePath_, Encoding.UTF8);
                mySettings_.Load(sr);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                if (sr != null)
                {
                    sr.Dispose();
                    sr = null;
                }
            }
        }

        private void _SaveSettings()
        {
            StreamWriter sw = null;

            try
            {
                sw = new StreamWriter(myFilePath_, false, Encoding.UTF8);
                mySettings_.Save(sw);
            }
            catch (Exception ex)
            {
                throw ex;
            }
            finally
            {
                if (sw != null)
                {
                    sw.Dispose();
                    sw = null;
                }
            }

        }

        private void _InitializeSettings()
        {
            XmlElement root = null;
            XmlElement ele = null;

            try
            {
                root = mySettings_.CreateElement("Settings");
                mySettings_.AppendChild(root);

                // 文字列
                ele = mySettings_.CreateElement("文字列");
                root.AppendChild(ele);

                ele.SetAttribute("文字数", "8");
                ele.SetAttribute("生成数", "1");
                ele.SetAttribute("使用可能記号", "!#$%&@");
                ele.SetAttribute("記号使用", "yes");
                ele.SetAttribute("日時使用", "no");

                ////// ショートカットキー
                ////ele = mySettings_.CreateElement("ショートカットキー");
                ////root.AppendChild(ele);

                // クリップボードへの転送方法
                ele = mySettings_.CreateElement("転送方法");
                root.AppendChild(ele);

                ele.SetAttribute("区切り文字", "改行");

                _SaveSettings();
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }

        private string _GetAttribute(string ElementName, string AttributeName)
        {
            XmlNodeList list = null;
            string value = "";

            try
            {
                list = mySettings_.GetElementsByTagName(ElementName);
                if (list.Count > 0)
                {
                    if ((list.Item(0).NodeType == XmlNodeType.Element) &&
                        (list.Item(0).Name == ElementName))
                    {
                        value = ((XmlElement)list[0]).GetAttribute(AttributeName);
                    }
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }

            return value;
        }

        private void _SetAttribute(string ElementName, string AttributeName, string Value)
        {
            XmlNodeList list = null;

            try
            {
                list = mySettings_.GetElementsByTagName(ElementName);
                if (list.Count > 0)
                {
                    if ((list.Item(0).NodeType == XmlNodeType.Element) &&
                        (list.Item(0).Name == ElementName))
                    {
                        ((XmlElement)list[0]).SetAttribute(AttributeName, Value);
                    }
                }

            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
    }
}
