﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace KeyShop
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }

        //########################################################
        //
        //  private variable
        //
        //########################################################

        private clsSettings mySettings_;

        // Control
        private bool myEventEnabled_ = false;

        //########################################################
        //
        //  public function
        //
        //########################################################

        public void xStart()
        {
            mySettings_ = new clsSettings();

            _Control("初期画面");
            this.Show();
            _Control("入力画面");
        }

        //########################################################
        //
        //  private function
        //
        //########################################################

        private void _Control(string Function)
        {
            this.myEventEnabled_ = false;

            this.mnu基本.Enabled = false;
            this.mnu操作.Enabled = false;
            this.btn生成.Enabled = false;

            if (Function == "初期画面")
            {
                this.cmb文字数.Items.Clear();
                this.cmb文字数.Items.Add("4");
                this.cmb文字数.Items.Add("5");
                this.cmb文字数.Items.Add("6");
                this.cmb文字数.Items.Add("7");
                this.cmb文字数.Items.Add("8");
                this.cmb文字数.Items.Add("9");
                this.cmb文字数.Items.Add("10");
                this.cmb文字数.Text = mySettings_.xGetAttribute("文字列", "文字数");

                this.cmb生成数.Items.Clear();
                this.cmb生成数.Items.Add("1");
                this.cmb生成数.Items.Add("10");
                this.cmb生成数.Items.Add("20");
                this.cmb生成数.Items.Add("30");
                this.cmb生成数.Items.Add("50");
                this.cmb生成数.Items.Add("100");
                this.cmb生成数.Text = mySettings_.xGetAttribute("文字列", "生成数");

                this.cmb記号.Items.Clear();
                this.cmb記号.Items.Add("記号を含める");
                this.cmb記号.Items.Add("記号を含めない");
                if (mySettings_.xGetAttribute("文字列", "記号使用").ToLower() == "yes")
                {
                    this.cmb記号.Text = "記号を含める";
                }
                else
                {
                    this.cmb記号.Text = "記号を含めない";
                }

                this.cmb日時.Items.Clear();
                this.cmb日時.Items.Add("日時を含める");
                this.cmb日時.Items.Add("日時を含めない");
                if (mySettings_.xGetAttribute("文字列", "日時使用").ToLower() == "yes")
                {
                    this.cmb日時.Text = "日時を含める";
                }
                else
                {
                    this.cmb日時.Text = "日時を含めない";
                }

                this.cmb区切り文字.Items.Clear();
                this.cmb区切り文字.Items.Add("改行");
                this.cmb区切り文字.Items.Add("カンマ");
                this.cmb区切り文字.Items.Add("タブ");
                this.cmb区切り文字.Text = mySettings_.xGetAttribute("転送方法", "区切り文字");
            }
            else if (Function == "入力画面")
            {
                this.mnu基本.Enabled = true;
                this.mnu終了.Enabled = true;
                this.mnu操作.Enabled = true;
                this.mnu生成.Enabled = true;
                this.btn生成.Enabled = true;
            }
            else if (Function == "生成")
            {
                _SaveSettings();
                _生成();
                _Control("入力画面");
            }
            else if (Function == "終了")
            {
                this.Close();
            }


            this.myEventEnabled_ = true;

        }

        private void _SaveSettings()
        {
            mySettings_.xSetAttribute("文字列", "文字数", this.cmb文字数.Text);
            mySettings_.xSetAttribute("文字列", "生成数", this.cmb生成数.Text);
            if (this.cmb記号.Text == "記号を含める")
            {
                mySettings_.xSetAttribute("文字列", "記号使用", "yes");
            }
            else
            {
                mySettings_.xSetAttribute("文字列", "記号使用", "no");
            }
            if (this.cmb日時.Text == "日時を含める")
            {
                mySettings_.xSetAttribute("文字列", "日時使用", "yes");
            }
            else
            {
                mySettings_.xSetAttribute("文字列", "日時使用", "no");
            }
            mySettings_.xSetAttribute("転送方法", "区切り文字", this.cmb区切り文字.Text);

            mySettings_.xSaveSettings();
        }

        private void _生成()
        {
            clsMain clsMain = new clsMain();
            clsMain.xCreatePassword();
        }

        //########################################################
        //
        //  event function
        //
        //########################################################

        private void Menu_Click(object sender, EventArgs e)
        {
            ToolStripMenuItem menu = (ToolStripMenuItem)sender;

            this.Cursor = Cursors.WaitCursor;
            if (menu == this.mnu終了)
            {
                _Control("終了");
            }
            else if (menu == this.mnu生成)
            {
                _Control("生成");
            }
            this.Cursor = Cursors.Default;
        }

        private void cmb文字数_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar < '0' || e.KeyChar > '9')
            {
                e.Handled = true;
            }
        }

        private void Button_Click(object sender, EventArgs e)
        {
            this.Menu_Click(this.mnu生成, null);
        }

    }
}
